#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <process.h>

char * ptr = {
#include "PCL836.mem"
};

#define VIDEO  0x10
#define ARR_UP 0x4800
#define ARR_DN 0x5000
#define ARR_R  0x4d00
#define ARR_L  0x4b00
#define SPACE  0x3920
#define ENTER  0x1c0d
#define ESC    0x011b

int PCB_NORM_BACK = BLUE ;
int PCB_NORM_FORE = WHITE ;
int BASE_ADD=0x240,IRQ_NO=1;
int dout,din;
//unsigned readback[6];

float cnt[6]={0xffff,0xffff,0xffff,0xffff,0xffff,0xffff};
char  source[6]={0,0,0,0,0,0};
char  trigger[6]={0,0,0,0,0,0};
char  filter[6]={0,0,0,0,0,0};
char  read_back[6]={0,0,0,0,0,0};
char  pwm_on[6]={0,0,0,0,0,0};

float freq[6]={3,3,3,3,3,3};

int  multi_mem(void);
void add_irq(void);
void dig_out(void);
void fout(void);
void counter(void);
void pwm(void);
void clock_gen(int clock_num,int clock_value);
void event_counter(int counter_num,char edge,char filter,char bcd,char source,unsigned counter_value);
void pwm_counter(int counter_num,char edge,char filter,char bcd,char source,unsigned counter_value);

unsigned read(int number);

void cursor_on_off(int on)
     {
      union REGS regs;
      regs.h.ah = 0x01;  /* set cursor type function */
      if(!on) regs.h.ch = 0x30;  /* set top scan line */
      else    regs.h.ch = 0x15;
      regs.h.cl = 0x0c;  /* set bottom scan line */
      int86(VIDEO, &regs, &regs);
     }
void fill_scr(void)
     {
      int j;
      textbackground(BLUE);
      clrscr();
      for(j=0;j<3998;j=j+2)
      {
        textattr(*(ptr+j+1));
        cprintf("%c",*(ptr+j));
      }
     }
void put_status(int color,char *stream1,char *stream2,char *stream3)
  {
    textbackground(BLACK);
    textcolor(color);
    gotoxy(2,10);
    cprintf("%s",stream1);
    gotoxy(2,11);
    cprintf("%s",stream2);
    gotoxy(2,12);
    cprintf("%s",stream3);
    textbackground(PCB_NORM_BACK);
    textcolor(PCB_NORM_BACK);
    gotoxy(79,25);
    cputs(" ");
  }
void int_set(int irq)
     {
      gotoxy(25,7);
      switch(irq){
        case 2 :printf("");break;
        case 3 :printf("۰");break;
        case 4 :printf("۰");break;
        case 5 :printf("۰");break;
        case 6 :printf("۰");break;
        case 7 :printf("۰");break;
        case 10:printf("۰");break;
        case 11:printf("۰");break;
        case 12:printf("۰");break;
        case 15:printf("۰");break;
     }
}
void sw_set(int sw )
     {
      int  i;
      char temp,val=0x20;

      textbackground(PCB_NORM_BACK);
      textcolor(BLINK+LIGHTRED);
      //gotoxy(38,22);
      //cputs("SW1");
      textbackground(PCB_NORM_BACK);
      textcolor(PCB_NORM_FORE);
      temp = (( sw >> 4) & 0x00ff);
      for(i=12;i<16;i++)
         {
           gotoxy(i,6);
           if(temp & val) { cprintf("%c",0xdc); }
           else cprintf("%c",0xdf);
           val = val >> 1 ;
         }
      gotoxy(i,6);
      if(temp & val) { cprintf("%c",0xdc); }
      else cprintf("%c",0xdf);
      textbackground(PCB_NORM_BACK);
      textcolor(PCB_NORM_BACK);
      gotoxy(2,2);
      cputs(" ");
     }

void nor_sw_set( void )
     {
      textbackground(PCB_NORM_BACK);
      textcolor(YELLOW);
      //gotoxy(12,6);
      //cputs("SW1");
      textbackground(PCB_NORM_BACK);
      textcolor(PCB_NORM_BACK);
      gotoxy(2,2);
      cputs(" ");
     }

void bye(void)
    {
      int count;

      textbackground(BLACK);
      textcolor(LIGHTGRAY);
      clrscr();
      textbackground(BLUE);
      textcolor(YELLOW);
      cprintf("%c",0xc9);
      for(count=1;count<44;count++)
         cprintf("%c",0xcd);
      cprintf("%c\r\n",0xbb);
      cprintf("%c                                           %c\r\n",0xba,0xba);
      cprintf("%c           Thank you for using             %c\r\n",0xba,0xba);
      cprintf("%c                                           %c\r\n",0xba,0xba);
      cprintf("%c       PCL-836 REV.A1 test program  !!     %c\r\n",0xba,0xba);
      cprintf("%c                                           %c\r\n",0xba,0xba);
      cprintf("%c                                           %c\r\n",0xba,0xba);
      cprintf("%c                       ADVANTECH CO.,LTD.  %c\r\n",0xba,0xba);
      cprintf("%c",0xc8);
      for (count=1;count<44;count++)
         cprintf("%c",0xcd);
      cprintf("%c\r\n",0xbc);
      textbackground(BLACK);
      textcolor(LIGHTGRAY);
      cputs(" ");
      exit(0);
    }
int  wait_key(void)
    {
       int c,i;

       while (bioskey(1) == 0 ){
         din=inport(BASE_ADD+0X10);
         cursor_on_off(0);
         for(i=0;i<=15;i++){
            gotoxy(78-i*2,8);
            textbackground(BLUE);
            textcolor(WHITE);
            cprintf("%d",(din>>i)&0x0001);
         }
         for(i=0;i<6;i++){
            if(read_back[i]){
              gotoxy(50,12+i);
              cprintf("%5u  ",read(i));
            }
         }
       }
       cursor_on_off(1);
       c=bioskey(0);
       if( c == ESC ) {
          bye();
          exit(0) ;
       }
       return c;
    }


void main()
{
  fill_scr();
  do{
      switch(multi_mem())
      {
        case 0 : add_irq() ; break;
        case 1 : dig_out() ; break;
        case 2 : fout()    ; break;
        case 3 : counter() ; break;
        case 4 : pwm()     ; break;
        case 5 : bye();   exit(0)  ;
     }
  } while(1);
}

int multi_mem(void)
{
  static int function=0;
  int i,key=0;
  put_status(YELLOW,"Use   to select function,        "
                   ,"then press enter.                  "
                   ,"Esc to quit.                       ");
  do{
     textbackground(BLACK);
     textcolor(YELLOW);

     gotoxy(38,2);cprintf("ADD & IRQ");
     gotoxy(49,2);cprintf("DIG OUT")  ;
     gotoxy(59,2);cprintf("FOUT")     ;
     gotoxy(66,2);cprintf("COUNTER")  ;
     gotoxy(75,2);cprintf("PWM")      ;
     gotoxy(32,2);cprintf("QUIT")     ;

     textbackground(YELLOW);
     textcolor(BLACK);
     switch (function) {
       case 0 : gotoxy(38,2);cprintf("ADD & IRQ"); break;
       case 1 : gotoxy(49,2);cprintf("DIG OUT")  ; break;
       case 2 : gotoxy(59,2);cprintf("FOUT")     ; break;
       case 3 : gotoxy(66,2);cprintf("COUNTER")  ; break;
       case 4 : gotoxy(75,2);cprintf("PWM")      ; break;
       case 5 : gotoxy(32,2);cprintf("QUIT")     ; break;
     }
     key=wait_key();
     switch (key) {
       case ARR_R : if(function<5) function ++ ;
                    else function =0;
                    break;
       case ARR_L : if(function>0) function -- ;
                    else function =5;
                    break;
     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R))
       { cprintf("\a"); }
  }while ((key != SPACE)&&(key != ENTER));
  return function;
}
void add_irq(void)
{
   int a_i=0,key;
   do{
     textbackground(BLACK);
     textcolor(YELLOW);
     gotoxy(2,4);cprintf("BASE ADDRESS =");
     gotoxy(22,4);cprintf("IRQ NUMBER =")  ;
     switch (a_i) {
       case 0 : put_status(YELLOW,"Press   to change base address.  ",
                                  "Press   to next item (IRQ set).  ",
                                  "ENTER to return previous menu.     ");
                textbackground(YELLOW);textcolor(BLACK);
                gotoxy(2,4);cprintf("BASE ADDRESS ="); break;
       case 1 : put_status(YELLOW,"Press   to change IRQ number.    ",
                                  "Press   to next item (BASE ADD). ",
                                  "ENTER to return previous menu.     ");
                textbackground(YELLOW);textcolor(BLACK);
                gotoxy(22,4);cprintf("IRQ NUMBER =")  ; break;
     }
     key=wait_key();
     switch (key) {
       case ARR_R : if(a_i==0) a_i ++ ;
                    else a_i = 0;
                    break;
       case ARR_L : if(a_i==1) a_i -- ;
                    else a_i = 1;
                    break;
       case ARR_UP: if((a_i==0)&(BASE_ADD<0X3a0)) BASE_ADD=BASE_ADD+0X20;
                    else if((a_i==0)&(BASE_ADD==0x3a0)) BASE_ADD=0X200;
                    else if((a_i==1)&(IRQ_NO<15)) {
                         if(IRQ_NO==7) IRQ_NO=10;
                         else if(IRQ_NO==12)IRQ_NO=15;
                         else IRQ_NO=IRQ_NO++;
                    }
                    else IRQ_NO=2;
                    sw_set(BASE_ADD);
                    int_set(IRQ_NO);
                    gotoxy(17,4);printf("%3X",BASE_ADD);
                    if(IRQ_NO!=1){
                       gotoxy(35,4);printf("%2d",IRQ_NO);
                    }
                    break;

       case ARR_DN: if((a_i==0)&(BASE_ADD>0x200)) BASE_ADD=BASE_ADD-0X20;
                    else if((a_i==0)&(BASE_ADD==0x200)) BASE_ADD=0X3a0;
                    else if((a_i==1)&(IRQ_NO>2)) {
                         if(IRQ_NO==10) IRQ_NO=7;
                         else if(IRQ_NO==15)IRQ_NO=12;
                         else IRQ_NO=IRQ_NO--;
                    }
                    else IRQ_NO=15;
                    sw_set(BASE_ADD);
                    int_set(IRQ_NO);
                    gotoxy(17,4);printf("%3X",BASE_ADD);
                    if(IRQ_NO!=1){
                      gotoxy(35,4);printf("%2d",IRQ_NO);
                    }
                    break;

     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R)&&
        (key != ARR_UP)&&(key != ARR_DN))
       { cprintf("\a"); }
  }while (key != ENTER);

  textbackground(BLUE);
  textcolor(WHITE);
  gotoxy(2,4);cprintf("BASE ADDRESS =");
  gotoxy(22,4);cprintf("IRQ NUMBER =")  ;
}

void dig_out(void)
{
  int bit_no=0,key;
  int i,x;

  do{
     x=78-bit_no*2;
     gotoxy(x,6);
     textbackground(YELLOW);
     textcolor(BLACK);
     cprintf("%d",(dout>>bit_no)&0x0001);
     gotoxy(x,6);
     put_status(YELLOW,"Press   to change D/O bit No.    ",
                       "Press SPACE to toggle DIG OUTPUT.  ",
                       "ENTER to return previous menu.     ");

     key=wait_key();
     switch (key) {
       case ARR_R : if (bit_no>0) bit_no-- ;
                    else bit_no=15 ;
                    break;
       case ARR_L : if (bit_no<15) bit_no++ ;
                    else bit_no=0 ;
                    break;
       case ARR_UP: dout |= (0x0001<<bit_no);
                    break;
       case ARR_DN: dout &=~(0x0001<<bit_no);
                    break;
       case SPACE : if((0x0001<<bit_no)&dout) dout &=~(0x0001<<bit_no);
                    else                      dout |= (0x0001<<bit_no);
                    break;
     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R)&&
        (key != ARR_UP)&&(key != ARR_DN))
       { cprintf("\a"); }
     for(i=0;i<16;i++){
        x=78-i*2;
        gotoxy(x,6);
        textbackground(BLUE);
        textcolor(WHITE);
        cprintf("%d",(dout>>i)&0x0001);
     }
     outport(BASE_ADD+0X10,dout);
  }while (key != ENTER);
  x=78-bit_no*2;
  gotoxy(x,6);
  textbackground(BLUE);
  textcolor(WHITE);
  cprintf("%d",(dout>>bit_no)&0x0001);
}
void fout(void)
{
 static char  on[6]={0,0,0,0,0,0};
 float data=0;
 char  on_off=0;
 int   key,row=0,col=0;
 int   x,y,i=0,j=0,k=0;

 do{
     for(i=0;i<6;i++){
       y=14+i*2;
       gotoxy(11,y);
       textbackground(BLUE);
       textcolor(WHITE);
       if(freq[i]>1) data=10e6/freq[i];
       else data=0;
       cprintf("%7.0f",data);
       clock_gen(i,freq[i]);
       if(on[i]) on_off|= (0x01<<i);
       else      on_off&=~(0x01<<i);
       outportb(BASE_ADD+24,on_off);
     }

     for(i=0;i<2;i++){
       for(j=0;j<6;j++){
          x=28+i*6;
          y=14+j*2;
          gotoxy(x,y);
          textbackground(BLUE);
          textcolor(WHITE);
          if(i==0) cprintf("%5.0f",freq[j]);
          else if(on[j]) cprintf(" ON");
          else           cprintf("OFF");
       }
     }

     x=28+row*6;
     y=14+col*2;
     gotoxy(x,y);
     textbackground(YELLOW);
     textcolor(BLACK);
     if(row==0) cprintf("%5.0f",freq[col]);
     else if(on[col]) cprintf(" ON");
     else             cprintf("OFF");

     put_status(YELLOW,"        10 MHz    X  [ 2 , 65535 ]",
                       "FOUT = ---------                   ",
                       "           X      X is integer     ");

     key=wait_key();
     switch (key) {
       case ARR_R : if (row>0) row-- ;
                    else row=1 ;
                    break;
       case ARR_L : if (row<1) row++ ;
                    else row=0 ;
                    break;
       case ARR_UP: if (col>0) col-- ;
                    else col=5;
                    break;
       case ARR_DN: if (col<5) col++ ;
                    else col=0;
                    break;
       case SPACE : if(row==1) on[col]=!on[col];
                    else {freq[col]=k=0;}
                    break;
       default    : if((row==0)&&(key<=0x0b30)&&(key>=0x0231)
                       &&(k<5)&&(freq[col]<=65535)){
                       data=freq[col]*10+(key&0x000f);
                       if (data<=65535) freq[col]=data;
                       k++;
                    }
                    else k=0;
     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R)&&
        (key != ARR_UP)&&(key != ARR_DN)&&!(key<=0x0b30)&&(key>=0x0231))
       { cprintf("\a"); }
  }while((key != ENTER));
     for(i=0;i<2;i++){
       for(j=0;j<6;j++){
          x=28+i*6;
          y=14+j*2;
          gotoxy(x,y);
          textbackground(BLUE);
          textcolor(WHITE);
          if(i==0) cprintf("%5.0f",freq[j]);
          else if(on[j]) cprintf(" ON");
          else           cprintf("OFF");
       }
     }
}
void counter(void)
{
  float data=0;
  int  key,row=0,col=0;
  int  x,y,i=0,j=0,k=0;

  do{
     for(i=0;i<6;i++){
       gotoxy(67,12+i);
       if(filter[i]) cprintf("%6.1f",freq[i]*8/10);
       else cprintf("       us");
       if(!pwm_on[i])
          event_counter(i,trigger[i],filter[i],0,source[i],(unsigned)cnt[i]);
       else
          pwm_counter(i,trigger[i],filter[i],0,source[i],(unsigned)cnt[i]);
     }
     for(i=0;i<4;i++){
       for(j=0;j<6;j++){
         y=12+j;
         textbackground(BLUE);
         textcolor(WHITE);
         switch(i){
           case 0 : x=41;gotoxy(x,y);cprintf("%5.0f",cnt[j]);break;
           case 1 : x=50;gotoxy(x,y);if(!read_back[j]){
                                       if(source[j]) cprintf("INTERNAL  ");
                                       else  cprintf("EXTERNAL  ");
                                     }
                                     else {
                                            gotoxy(57,y);
                                            if(source[j]) cprintf("INT");
                                            else          cprintf("EXT");
                                          }
                                     break;
           case 2 : x=62;gotoxy(x,y);if(trigger[j]) cprintf("  ");
                                     else  cprintf("  "); break;
           case 3 : x=77;gotoxy(x,y);if(filter[j]) cprintf("ON ");
                                     else  cprintf("OFF");break;
         }
       }
     }
     y=12+col;
     textbackground(YELLOW);
     textcolor(BLACK);
     switch(row){
       case 0 : x=41;gotoxy(x,y);cprintf("%5.0f",cnt[col]);break;
       case 1 : x=50;gotoxy(x,y);if(!read_back[col]){
                                   if(source[col]) cprintf("INTERNAL  ");
                                   else      cprintf("EXTERNAL  ");
                                 }
                                 else {
                                        gotoxy(57,y);
                                        if(source[col]) cprintf("INT");
                                        else            cprintf("EXT");
                                      }
                                 break;
       case 2 : x=62;gotoxy(x,y);if(trigger[col]) cprintf("  ");
                                 else  cprintf("  "); break;
       case 3 : x=77;gotoxy(x,y);if(filter[col])   cprintf("ON ");
                                 else  cprintf("OFF");break;
     }
     put_status(YELLOW,"Press C to display current counter ",
                       "Press SPACE to toggle select.      ",
                       "ENTER to return previous menu.     ");

     key=wait_key();
     switch (key) {
       case ARR_L : if (row>0) row-- ;
                    else row=3 ;
                    break;
       case ARR_R : if (row<3) row++ ;
                    else row=0 ;
                    break;
       case ARR_UP: if (col>0) col-- ;
                    else col=5;
                    break;
       case ARR_DN: if (col<5) col++ ;
                    else col=0;
                    break;
       case SPACE : switch(row) {
                      case 0: cnt[col]=k=0;break;
                      case 1: source[col]=!source[col];
                              if(source[col])
                                filter[col]=0;
                              break;
                      case 2: trigger[col]=!trigger[col];break;
                      case 3: if(!source[col])
                                filter[col]=!filter[col];
                              break;
                    }
                    break;
       case 0x2e63: read_back[col]=!read_back[col];
                    break;
       case 0x2e43: read_back[col]=!read_back[col];
                    break;
       default    : if((row==0)&&(key<=0x0b30)&&(key>=0x0231)
                       &&(k<5)&&(cnt[col]<=65535)){
                       data=cnt[col]*10+(key&0x000f);
                       if (data<=65535) cnt[col]=data;
                       k++;
                    }
                    else k=0;
     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R)&&
        (key != ARR_UP)&&(key != ARR_DN)&&!(key<=0x0b30)&&(key>=0x0231)&&
        (key!=0x2e63)&&(key!=0x2e43))
       { cprintf("\a"); }
  }while((key != ENTER));
     for(i=0;i<4;i++){
       for(j=0;j<6;j++){
         y=12+j;
         textbackground(BLUE);
         textcolor(WHITE);
         switch(i){
           case 0 : x=41;gotoxy(x,y);cprintf("%5.0f",cnt[j]);break;
           case 1 : x=50;gotoxy(x,y);if(!read_back[j]){
                                       if(source[j]) cprintf("INTERNAL  ");
                                       else  cprintf("EXTERNAL  ");
                                     }
                                     else {
                                           gotoxy(57,y);
                                           if(source[j]) cprintf("INT");
                                           else          cprintf("EXT");
                                          }
                                     break;
           case 2 : x=62;gotoxy(x,y);if(trigger[j]) cprintf("  ");
                                     else  cprintf("  "); break;
           case 3 : x=77;gotoxy(x,y);if(filter[j]) cprintf("ON ");
                                     else  cprintf("OFF");break;
         }
       }
     }
}
void pwm(void)
{
  float data;
  int  key,row=0,col=0;
  int  x,y,i=0,j=0,k=0;

  do{
     for(j=0;j<5;j++){
       for(i=0;i<3;i++){
         x=51+10*i;
         y=20+j;
         gotoxy(x,y);
         textbackground(BLUE);
         textcolor(WHITE);
         switch(j){
           case 0:{
             if(pwm_on[i]){
               cprintf("  ON  ");source[i]=2;source[i+3]=1;
               pwm_counter(i,trigger[i],filter[i],0,source[i],(unsigned)cnt[i]);
               pwm_counter(i+3,trigger[i+3],filter[i+3],0,source[i+3],(unsigned)cnt[i+3]);
             }
             else         {cprintf("  OFF ");source[i]=1;}
             break;
           }
           case 1:{
             if(pwm_on[i]) {
                data=((float)cnt[i+3]*freq[i])/10e3;
                if(data>10000) cprintf("%6.2fs",data/1000);
                else        cprintf("%6.2fms",data);
             }
             else          cprintf("        ");
             break;
           }
           case 2:{
             if(pwm_on[i]) {
                data=(float)(cnt[i+3]-(cnt[i]+2))*freq[i]/10e3;
                if(data>10000) cprintf("%6.2fs",data/1000);
                else         cprintf("%6.2fms",data);
             }
             else          cprintf("        ");
             break;
           }
           case 3:{
             if(pwm_on[i]){
                data=(float)(cnt[i]+2)*freq[i]/10e3;
                if(data>10000) cprintf("%6.2f",data/1000);
                else         cprintf("%6.2f",data);
             }
             else          cprintf("        ");
             break;
           }
           case 4:{
             if(pwm_on[i]) cprintf(" %2.1f%",(float)(cnt[i+3]-cnt[i]-2)*100/(float)cnt[i+3]);
             else          cprintf("       ");
             break;
           }
         }
       }
     }
     x=51+10*row;
     gotoxy(x,20);
     textbackground(YELLOW);
     textcolor(BLACK);
     if(pwm_on[row]) cprintf("  ON ");
     else            cprintf("  OFF ");
     put_status(YELLOW,"Press    to select PWM number.   ",
                       "Counter 3,4,5 > Counter 0,1,2      ",
                       "ENTER to return previous menu.     ");
     key=wait_key();
     switch (key) {
       case ARR_L : if (row>0) row-- ;
                    else row=2 ;
                    break;
       case ARR_R : if (row<2) row++ ;
                    else row=0 ;
                    break;
       case SPACE : pwm_on[row]=!pwm_on[row];
                    break;
     }
     if((key != SPACE)&&(key != ENTER)&&(key != ARR_L)&&(key != ARR_R)&&
        (key != ARR_UP)&&(key != ARR_DN)&&!(key<=0x0b30)&&(key>=0x0231)&&(key!=0x2e63))
       { cprintf("\a"); }
  }while((key != ENTER));
  for(i=0;i<3;i++){
     x=51+10*i;
     y=20;
     gotoxy(x,y);
     textbackground(BLUE);
     textcolor(WHITE);
     if(pwm_on[i]){
       cprintf("  ON  ");source[i]=2;source[i+3]=1;
       pwm_counter(i,trigger[i],filter[i],0,source[i],(unsigned)cnt[i]);
       pwm_counter(i+3,trigger[i+3],filter[i+3],0,source[i+3],(unsigned)cnt[i+3]);
     }
     else {cprintf("  OFF ");source[i]=1;}
  }
}
void clock_gen(int clock_num,int clock_value)
{
  int mode_8254=0x00;
  int counter_lo,counter_hi;
  /* 8254 mode control */
  counter_lo=(clock_value&0x00ff);
  counter_hi=(clock_value>>8);
  switch(clock_num){
       case 0:
         mode_8254=0x36|mode_8254;
         outportb(BASE_ADD+0x3,mode_8254);
         outportb(BASE_ADD+0x0,counter_lo); // filter  1
         outportb(BASE_ADD+0x0,counter_hi);
         break;
       case 1:
         mode_8254=0x76|mode_8254;
         outportb(BASE_ADD+0x3,mode_8254);
         outportb(BASE_ADD+0x1,counter_lo); // filter  2
         outportb(BASE_ADD+0x1,counter_hi);
         break;
       case 2:
         mode_8254=0xb6|mode_8254;
         outportb(BASE_ADD+0x3,mode_8254);
         outportb(BASE_ADD+0x2,counter_lo); // filter  3
         outportb(BASE_ADD+0x2,counter_hi);
         break;
       case 3:
         mode_8254=0x36|mode_8254;
         outportb(BASE_ADD+0x7,mode_8254);
         outportb(BASE_ADD+0x4,counter_lo); // filter  4
         outportb(BASE_ADD+0x4,counter_hi);
         break;
       case 4:
         mode_8254=0x76|mode_8254;
         outportb(BASE_ADD+0x7,mode_8254);
         outportb(BASE_ADD+0x5,counter_lo); // filter  5
         outportb(BASE_ADD+0x5,counter_hi);
         break;
       case 5:
         mode_8254=0xb6|mode_8254;
         outportb(BASE_ADD+0x7,mode_8254);
         outportb(BASE_ADD+0x6,counter_lo); // filter  6
         outportb(BASE_ADD+0x6,counter_hi);
         break;
  }
}
void event_counter(int counter_num,char edge,char filter,char bcd,char source,unsigned counter_value)
{
  int base_con;
  int control_reg,mode_8254;
  unsigned counter_lo,counter_hi;
  base_con=counter_num+0x12;
  control_reg=0x00;
  if(filter==1)
     control_reg=0x01;
  if(edge==1)
     control_reg=control_reg|0x04;
  if(source==1)
     control_reg=control_reg|0x02;
  //if(source==2)
  //   control_reg=control_reg|0x03;
  /* Counter control */
  outportb(BASE_ADD+base_con,control_reg);

  /* 8254 mode control */
  counter_lo =  (counter_value&0x00ff);
  counter_hi =  (counter_value>>8);
  mode_8254=0x00;
  if(bcd==1)
    mode_8254=0x01;
  switch(counter_num){
       case 0:
         mode_8254=0x34|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0x8,counter_lo); // Counter 1
         outportb(BASE_ADD+0x8,counter_hi);
         break;
       case 1:
         mode_8254=0x74|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0x9,counter_lo); // Counter 2
         outportb(BASE_ADD+0x9,counter_hi);
         break;
       case 2:
         mode_8254=0xb4|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0xa,counter_lo); // Counter 3
         outportb(BASE_ADD+0xa,counter_hi);
         break;
       case 3:
         mode_8254=0x34|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xc,counter_lo); // Counter 4
         outportb(BASE_ADD+0xc,counter_hi);
         break;
       case 4:
         mode_8254=0x74|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xd,counter_lo); // Counter 5
         outportb(BASE_ADD+0xd,counter_hi);
         break;
       case 5:
         mode_8254=0xb4|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xe,counter_lo); // Counter 6
         outportb(BASE_ADD+0xe,counter_hi);
         break;
  }
}
void pwm_counter(int counter_num,char edge,char filter,char bcd,char source,unsigned counter_value)
{
  int base_con;
  int control_reg,mode_8254;
  unsigned counter_lo,counter_hi;
  base_con=counter_num+0x12;
  control_reg=0x00;
  if(filter==1)
     control_reg=0x01;
  if(edge==1)
     control_reg=control_reg|0x04;
  if(source==1)
     control_reg=control_reg|0x02;
  if(source==2)
     control_reg=control_reg|0x03;
  /* Counter control */
  outportb(BASE_ADD+base_con,control_reg);

  /* 8254 mode control */
  counter_lo =  (counter_value&0x00ff);
  counter_hi =  (counter_value>>8);
  mode_8254=0x00;
  if(bcd==1)
    mode_8254=0x01;
  switch(counter_num){
       case 0:
         mode_8254=0x3a|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0x8,counter_lo); // Counter 1
         outportb(BASE_ADD+0x8,counter_hi);
         break;
       case 1:
         mode_8254=0x7a|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0x9,counter_lo); // Counter 2
         outportb(BASE_ADD+0x9,counter_hi);
         break;
       case 2:
         mode_8254=0xba|mode_8254;
         outportb(BASE_ADD+0xb,mode_8254);
         outportb(BASE_ADD+0xa,counter_lo); // Counter 3
         outportb(BASE_ADD+0xa,counter_hi);
         break;
       case 3:
         mode_8254=0x34|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xc,counter_lo); // Counter 4
         outportb(BASE_ADD+0xc,counter_hi);
         break;
       case 4:
         mode_8254=0x74|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xd,counter_lo); // Counter 5
         outportb(BASE_ADD+0xd,counter_hi);
         break;
       case 5:
         mode_8254=0xb4|mode_8254;
         outportb(BASE_ADD+0xf,mode_8254);
         outportb(BASE_ADD+0xe,counter_lo); // Counter 6
         outportb(BASE_ADD+0xe,counter_hi);
         break;
  }
}unsigned read(int number)
{
  unsigned value;
  switch(number){
  case 0:
      outportb(BASE_ADD+0xb,0xc2);
      inportb(BASE_ADD+0x8);
      value=inportb(BASE_ADD+0x8)+inportb(BASE_ADD+0x8)*0x100;
      break;
  case 1:
      outportb(BASE_ADD+0xb,0xc4);
      inportb(BASE_ADD+0x9);
      value=inportb(BASE_ADD+0x9)+inportb(BASE_ADD+0x9)*0x100;
      break;
  case 2:
      outportb(BASE_ADD+0xb,0xc8);
      inportb(BASE_ADD+0xa);
      value=inportb(BASE_ADD+0xa)+inportb(BASE_ADD+0xa)*0x100;
      break;
  case 3:
      outportb(BASE_ADD+0xf,0xc2);
      inportb(BASE_ADD+0xc);
      value=inportb(BASE_ADD+0xc)+inportb(BASE_ADD+0xc)*0x100;
      break;
  case 4:
      outportb(BASE_ADD+0xf,0xc4);
      inportb(BASE_ADD+0xd);
      value=inportb(BASE_ADD+0xd)+inportb(BASE_ADD+0xd)*0x100;
      break;
  case 5:
      outportb(BASE_ADD+0xf,0xc8);
      inportb(BASE_ADD+0xe);
      value=inportb(BASE_ADD+0xe)+inportb(BASE_ADD+0xe)*0x100;
      break;
  }
  return value;
}
